/**
 * Dream
 * Copyright (C) 2003-2004 INRIA Rhone-Alpes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: mohamed.mokhtari@insa-lyon.fr
 *
 * Initial developer(s): Mohamed Mokhtari
 */

package org.objectweb.dream.router;

import org.objectweb.dream.Push;
import org.objectweb.dream.PushException;
import org.objectweb.dream.dreamannotation.DreamComponent;
import org.objectweb.dream.message.Message;
import org.objectweb.dream.protocol.ProtocolChunk;

@DreamComponent()
public class ProtocolChunkRouter extends AbstractRouterImpl {

   /**
    * @see org.objectweb.dream.router.AbstractRouterImpl#getOutput(Message)
    */
   protected Push getOutput(Message message) throws PushException {
       ProtocolChunk protocolChunk = (ProtocolChunk) messageManagerItf
           .getChunk(message, ProtocolChunk.DEFAULT_NAME);
       
       messageManagerItf.removeChunk(message, ProtocolChunk.DEFAULT_NAME);
       
       return outPushMap.get("out-push-" + protocolChunk.getProtocol());
   }
   
   /**
    * @see org.objectweb.fractal.api.control.BindingController#listFc()
    */
   public String[] listFc () {
       String []fc = null;
       
       if (defaultOutPushItf != null) {
           fc = new String [outPushMap.size() + 1];
           fc [fc.length - 1] = DEFAULT_OUT_PUSH_ITF_NAME;
       }
       else {
           fc = new String [outPushMap.size()];
       }
       
       System.arraycopy((String[])outPushMap.keySet().toArray(new String[outPushMap.size()]), 0, fc, 0, outPushMap.size());
       
       return fc;
   }
   
   /**
    * @see org.objectweb.fractal.api.control.BindingController#lookupFc(String)
    */
   public Object lookupFc (String itfName) {
       if (itfName.startsWith("out-push")) { 
           return outPushMap.get(itfName);
       }
       else if (DEFAULT_OUT_PUSH_ITF_NAME.equals(itfName)) {
           return defaultOutPushItf;
       }
       else {
           return null;
       }
   } 
}